from typing import Any, List

from word_search_generator.mask import shapes

ITERATIONS = 5
WORDS = "dog, cat, pig, horse, donkey, turtle, goat, sheep"

# Put all shape masks into a list for use in testing
BUILTIN_MASK_SHAPES_OBJECTS: List[Any] = []
for shape in shapes.BUILTIN_MASK_SHAPES:
    mask = eval(f"shapes.{shape}")()
    BUILTIN_MASK_SHAPES_OBJECTS.append(mask)

SHAPES_KNOWN_OUTPUT = {
    "Circle": """# # # # # # # * * * * * * * # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # # * * * * * * * # # # # # # #
""",
    "Club": """# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * # * * * # * * * * * # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
""",
    "Diamond": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
""",
    "Donut": """# # # # # # # * * * * * * * # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * # # # * * * * * * * * *
* * * * * * * * # # # # # * * * * * * * *
* * * * * * * # # # # # # # * * * * * * *
* * * * * * * # # # # # # # * * * * * * *
* * * * * * * # # # # # # # * * * * * * *
* * * * * * * * # # # # # * * * * * * * *
* * * * * * * * * # # # * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # # * * * * * * * # # # # # # #
""",
    "Fish": """# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
* * * # # # # # # # * * * * * * # # # # #
# # * * * # # # * * * * * * * * * * # # #
# # # * * * # * * * * * * * * * * * * # #
# # # # * * * * * * * * * * * * * * * * #
# # # # * * * * * * * * * * * * * * * * #
# # # # # * * * * * * * * * * * * * * * *
# # # # # * * * * * * * * * * * * * * * *
# # # # # * * * * * * * * * * * * * * * *
# # # # # * * * * * * * * * * * * * * * *
# # # # # * * * * * * * * * * * * * * * *
# # # # * * * * * * * * * * * * * * * * #
# # # # * * * * * * * * * * * * * * * * #
# # # * * * # * * * * * * * * * * * * # #
# # * * * # # # * * * * * * * * * * # # #
* * * # # # # # # # * * * * * * # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
    "Flower": """# # # # # # # * * * * * * * # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # * * # * * * * * * * * * * * # * * # #
# * * * * # * * * * * * * * * # * * * * #
# * * * * * # * * * # * * * # * * * * * #
* * * * * * * # * * # * * # * * * * * * *
* * * * * * * * # * # * # * * * * * * * *
* * * * * * * * * # # # * * * * * * * * *
* * * * * * # # # # # # # # # * * * * * *
* * * * * * * * * # # # * * * * * * * * *
* * * * * * * * # * # * # * * * * * * * *
* * * * * * * # * * # * * # * * * * * * *
# * * * * * # * * * # * * * # * * * * * #
# * * * * # * * * * * * * * * # * * * * #
# # * * # * * * * * * * * * * * # * * # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # # * * * * * * * # # # # # # #
""",
    "Heart": """# # # * * * * * # # # # # * * * * * # # #
# # * * * * * * * # # # * * * * * * * # #
# * * * * * * * * * # * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
""",
    "Hexagon": """# # # # # # # # # # # # # # # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
    "Octagon": """# # # # # # # # # # # # # # # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
    "Pentagon": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
    "Spade": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * # * * * # * * * * * # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
""",
    "Star5": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # * * * * * * * * * * * * * # # # #
* * * * * * * * * * * * * * * * * * * * *
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * # * * * * * * # # # #
# # # # * * * * # # # # # * * * * # # # #
# # # # * * # # # # # # # # # * * # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
    "Star6": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# * * * * * * * * * * * * * * * * * * * #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
""",
    "Star8": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # * * # # # # * * * # # # # * * # # #
# # # * * * * # * * * * * # * * * * # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # * * * * * * * * * * * * * * * * * # #
* * * * * * * * * * * * * * * * * * * * *
# # * * * * * * * * * * * * * * * * * # #
# # # # * * * * * * * * * * * * * # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * # * * * * * # * * * * # # #
# # # * * # # # # * * * # # # # * * # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # # * # # # # # # # # # #
""",
    "Tree": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
""",
    "Triangle": """# # # # # # # # # # * # # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # # * * * # # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # # * * * * * # # # # # # # #
# # # # # # # * * * * * * * # # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # # * * * * * * * * * # # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # # * * * * * * * * * * * # # # # #
# # # # * * * * * * * * * * * * * # # # #
# # # * * * * * * * * * * * * * * * # # #
# # # * * * * * * * * * * * * * * * # # #
# # * * * * * * * * * * * * * * * * * # #
# # * * * * * * * * * * * * * * * * * # #
# * * * * * * * * * * * * * * * * * * * #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
# # # # # # # # # # # # # # # # # # # # #
""",
}
